par_solve([]) ->
    [];
par_solve([[]|_]) ->
    false;
par_solve([[L|Lits]|Clauses]) ->
    Rest = speculate(fun()-> par_solve(unit_propagation(-L,[Lits|Clauses])) end),
    case par_solve(unit_propagation(L,Clauses)) of
	false ->
	    case value_of(Rest) of
		false ->
		    false;
		Solution ->
		    [-L|Solution]
	    end;
	Solution ->
	    [L|Solution]
    end.

speculate(F) ->
    Parent = self(),
    Pid = spawn_link(fun() -> Parent ! {self(),F()} end),
    {speculating,Pid}.

value_of({speculating,Pid}) ->
    receive {Pid,X} ->
	    X
    end.
