limit_solve(P) ->
    start_pool(erlang:system_info(schedulers)-1),
    S = limit_solve1(P),
    pool ! {stop,self()},
    receive {pool,stopped} -> S end.

limit_solve1([]) ->
    [];
limit_solve1([[]|_]) ->
    false;
limit_solve1([[L|Lits]|Clauses]) when length(Clauses) < 250 ->
    solve([[L|Lits]|Clauses]);
limit_solve1([[L|Lits]|Clauses]) ->
    Rest = speculate_on_worker(
	     fun()-> limit_solve1(unit_propagation(-L,[Lits|Clauses])) end),
    case limit_solve1(unit_propagation(L,Clauses)) of
	false ->
	    case worker_value_of(Rest) of
		false ->
		    false;
		Solution ->
		    [-L|Solution]
	    end;
	Solution ->
	    [L|Solution]
    end.
