{-# LANGUAGE OverloadedStrings #-}
module Styles (content, codeSlide, titled, titlefont, loneText, img) where
import Haste
import Haste.DOM
import Haste.Deck

lineHeight lh = withAttrs [style "line-height" =: lh]

content :: Slide -> Slide
content = font "Raleway" . lineHeight "1.5em" . fontSize (Pt 28) . centered

codeSlide c = row ["", sized 0.9 $ fontSize (Pt 24) (html c), ""]

titled :: String -> Slide -> Slide
titled t s = column [sized 0.1 "", sized 0.15 $ titlefont t, sized 0.1 "", content s]

titlefont =
  font "Raleway"
  . centered
  . fontSize (Pt 48)
  . text

loneText = verticallyCentered . titlefont

img = withAttrs [style "width" =: "90%"] . image
